\section{Introduction}
\label{sec:intro}

%Unit testing is a widely accepted and important measure of quality assurance
%in software development.
A \emph{unit test} for object-oriented programs consists of 
a sequence of method calls. 
Manually crafting test sequences is labor-intensive.
Random testing automatically generates test sequences to execute different
paths in a method under test (MUT)~\cite{Ham94}.
%It randomly constructs object instances as the receiver and input
%arguments of the MUT. 
However, it is well known that random testing techniques suffer 
from low code coverage on real-world applications~\cite{Godefroid:2005:DDA:1064978.1065036,Thummalapenta:2009:MOU:1595696.1595725}.
Reasons are that randomly generated sequences have low probability to set up the 
system in all the required
states~\cite{Thummalapenta:2009:MOU:1595696.1595725},
or that the required input arguments for invoking the MUT cannot 
be generated automatically.


%Object-oriented functions called \emph{methods} 
%operate on an object instance called the \emph{receiver instance.}
%Each invocation executes a specific path, depending on the program state.

%The code coverage of an MUT in
%a unit test depends on the states of both of its receiver and input arguments.    

Feedback-directed Random Testing~(FRT)~\cite{Pacheco:2005:EAG:2144892.2144921,Pacheco:2007:RFR:1297846.1297902}
%represents a state of the art of random testing techniques, which
%incorporates the test execution feedback in process.
%FRT randomly selects an MUT and reuses previously generated 
%method sequences~(that return objects) as input to execute the MUT.
%A successfully executed method call sequence is stored to generate certain objects
%in future iterations, while a method sequence that violates the pre-defined contract or
%causes failures is discarded.
%FRT
incrementally builds more and longer test sequences
by randomly selecting an MUT and reusing previously generated 
method sequences~(that return objects) as input to execute the MUT until a time limit is hit.
%by concatenating previously generated ones until a time limit is hit.
Tools such as Eclat~\cite{Pacheco:2005:EAG:2144892.2144921}, Randoop~\cite{Pacheco:2007:RFR:1297846.1297902}
%Recgen~\cite{Zheng:2010:RUG:1858996.1859054}, OCAT~\cite{Jaygarl:2010:OOC:1831708.1831729}, Palus~\cite{Zhang:2011:CSD:2001420.2001463}
adopt FRT. 
However, FRT still suffers
low code coverage in some cases~\cite{Thummalapenta:2009:MOU:1595696.1595725,Zhang:2011:CSD:2001420.2001463, Zheng:2010:RUG:1858996.1859054}.
The main reason is that MUTs often
contain branch conditions that require specific object states that
are not easily generated at random~\cite{Thummalapenta:2009:MOU:1595696.1595725}.
This limits many existing techniques that adopt FRT as basis~%
%cite some previous work that use techniques based on Randoop or compare with Randoop.
%We may need a table here to list which work leverage feedback-directed random testing in their work.
\cite{Jaygarl:2010:OOC:1831708.1831729,Zhang:2011:CSD:2001420.2001463, Zheng:2010:RUG:1858996.1859054,Thummalapenta:2009:MOU:1595696.1595725,Yi:2013:ECI:2483760.2483772,Winkler:2012:IUC:2368323.2368352,Inkumsah:2008:IST}.
%Fundamental improvements in feedback-directed random testing therefore
%also improve the performance of many related techniques and tools.


%which automatically generates method call~(test) sequences for object-oriented programs.
%Although FRT~\cite{Pacheco:2005:EAG:2144892.2144921}
%produces few illegal and redundant sequences, 

%tries to generate a method call
%sequence to create objects as the input to execute the MUT

%The approach randomly selects an MUT and tries to generate a method call
%sequence to create objects as the input to execute the MUT.
%
%A successfully executed method call sequence is stored to generate certain objects
%in future iterations. In this way, feedback-directed random testing incrementally 
%builds more and longer test sequences by concatenating previously generated ones 
%until a time limit is hit.

%Although FRT~\cite{Pacheco:2005:EAG:2144892.2144921}
%produces few illegal and redundant sequences, it still suffers from
%low code coverage in some cases. The main reason is that MUTs often
%contain branch conditions that require specific object states that
%are not easily generated at random~\cite{Thummalapenta:2009:MOU:1595696.1595725}.
%This limits many existing techniques that adopt FRT as basis~%
%%cite some previous work that use techniques based on Randoop or compare with Randoop.
%%We may need a table here to list which work leverage feedback-directed random testing in their work.
%\cite{Jaygarl:2010:OOC:1831708.1831729,Zhang:2011:CSD:2001420.2001463, Zheng:2010:RUG:1858996.1859054,Thummalapenta:2009:MOU:1595696.1595725,Yi:2013:ECI:2483760.2483772,Winkler:2012:IUC:2368323.2368352,Inkumsah:2008:IST}.
%%Fundamental improvements in feedback-directed random testing therefore
%%also improve the performance of many related techniques and tools.
 
In this paper, we first summarize several key issues that limit the potentiality 
of current FRT techniques.
Based on this, we propose a new approach called \emph{Guided Random Testing}~(GRT)
to address these issues systematically. 
GRT performs program analysis to guide test generation and
shares the common idea of FRT by leveraging the feedback of method execution.
%uses a set of program analysis techniques to enhance feedback-directed 
%random testing by addressing all the issues systematically.
 GRT works in two phases:
(1)~A static analysis over the classes under test extracts domain knowledge 
such as possible constants during execution, method side effects, and their 
dependencies. Based on these analysis results, GRT creates larger pools of initial 
constant values and methods which form the basis of method sequence generation.
(2)~At run-time, the static information is combined with dynamic feedback, such
as exact type information and test coverage information, to support demand-driven
object construction and to guide testing to those MUTs with low coverage. 

%We manage the generated sequences based on the dynamic type
%information and favor sequences with low execution time as input to other
%MUTs.

Our approach is fully automatic and does not require any input specification
or existing test cases.
We implement all the six main components of GRT as pluggable options based on 
the well-known FRT tool Randoop~\cite{Pacheco:2005:EAG:2144892.2144921}.
We perform a thorough evaluation of GRT on a large set of
benchmarks containing 30 popular real-world applications. The experiments
demonstrate the effectiveness of GRT with respect to code coverage, mutation
score, and real-world known and unknown defect detection in open source projects. 
%We also compare GRT with
%major peer techniques like the state of the art
%evolutionary testing tool EvoSuite~\cite{Fraser:2013:WTS:2478542.2478706}.

%We also conduct comparisons with the state of the art
%evolutionary testing tool EvoSuite~\cite{Fraser:2013:WTS:2478542.2478706}.
%to compare GRT with approaches that are not based on feedback-directed random testing.

In summary, this paper makes the following contributions:

\begin{enumerate}
\item We identify key issues that limit the test coverage of FRT.
%\item We identify key issues that limit the coverage of tests generated
%by FRT.
\item We propose and implement GRT as six fully
automatic components that extract and use domain knowledge and run-time information to guide testing.
\item We evaluate GRT on 30 real-world programs in terms of code coverage
	and mutation score, comparing it with major peer techniques 
	(i.\,e., Randoop and EvoSuite~\cite{Fraser:2013:WTS:2478542.2478706}).
\item We investigate the defect detection ability of our techniques on
both known and unknown bugs.
\end{enumerate}
 
 
%We found that Randoop shows several limitations in practical applications
%despite its versatility:
%
%\begin{enumerate}
%\item Small constant pool. Randoop uses a small pool of predefined constants and 
%primitive values observed at run-time as inputs. Many relevant
%values are missed.
%
%\item No distinction between methods with and without side effects.
%Pure methods do not change the object state and may add long
%redundant subsequences to a test.
%
%\item Static type management. This limits coverage in cases where the
%dynamic type differs from the declared type.
%
%\item Fixed method pool. An unordered, fixed
%set of methods to test may prevent some methods from ever being executed
%due to unfulfilled dependencies.
%
%\item Lengthy input sequences. Randoop has no bias towards light-weight
%methods, which in general results in long test sequence execution times
%at a later phase.
%\item No run-time coverage guidance. Randoop selects the
%methods to test with no bias,
%choosing easily covered and hard-to-cover methods
%with the same probability.
%\end{enumerate}
%
%To address these limitations, we first perform a static analysis on the
%classes under test. This step extracts domain knowledge such as possible constants
%during execution, method side effects, and their dependencies. The results are
%later combined with the run-time input, demand-driven object construction, and
%coverage information techniques, to guide testing to those MUTs with low
%coverage. We manage the generated sequences based on the dynamic type
%information and favor sequences with low execution time as input to other
%MUTs. Our approach is fully automated and requires no specification of
%possible inputs.
%We implement our techniques as pluggable options based on Randoop.
%The evaluation of our approach on 30 popular real-world applications
%demonstrates its effectiveness.


This paper is organized as follows:
Section~\ref{sec:background} gives the background of our work
and describes related work.
%%Section~\ref{sec:weaknesses} describes
%%weaknesses we found when applying Randoop to existing programs.
Section~\ref{sec:enhancements} presents overall design of GRT and each of its components in detail.
%%explains the overall design of our approach and discusses each component of GRT in detail.
%%our approach in detail to improve on the limitations of feedback directed random testing.
After presenting the implementation and evaluation of GRT in Section~\ref{sec:implementation} and Section~\ref{sec:experiments},
%%of GRT in Section~\ref{sec:implementation}, Section~\ref{sec:experiments} thoroughly evaluates our work on 30 real-world software projects.
Section~\ref{sec:conclusion} concludes and discusses future work.
